commit 599a39cdec4ceb30754ede873cda4c36703e9ce4
Author: Assos Assos <assos+forge@centrale-marseille.fr>
Date:   Wed Mar 10 23:28:35 2021 +0100

    Weekly update of contrib modules

diff --git a/drupal7/sites/all/modules/date/date.api.php b/drupal7/sites/all/modules/date/date.api.php
index 268ae868..df3090ad 100644
--- a/drupal7/sites/all/modules/date/date.api.php
+++ b/drupal7/sites/all/modules/date/date.api.php
@@ -40,7 +40,7 @@ function hook_date_default_argument_alter(&$argument, &$value) {
  *   - rdf_mapping: The RDF mapping array.
  *   - add_rdf: If module_exists('rdf').
  */
-function hook_date_formatter_pre_view_alter(&$entity, &$variables) {
+function hook_date_formatter_pre_view_alter(&$entity, array &$variables) {
   if (!empty($entity->view)) {
     $field = $variables['field'];
     $date_id = 'date_id_' . $field['field_name'];
@@ -68,7 +68,7 @@ function hook_date_formatter_pre_view_alter(&$entity, &$variables) {
  *   - item: The $item array.
  *   - display: The $display array.
  */
-function hook_date_formatter_dates_alter(&$dates, $context) {
+function hook_date_formatter_dates_alter(array &$dates, array $context) {
   $field = $context['field'];
   $instance = $context['instance'];
   $format = $context['format'];
@@ -90,7 +90,8 @@ function hook_date_formatter_dates_alter(&$dates, $context) {
       'date2' => $date2,
       'format' => $format,
       'entity_type' => $entity_type,
-      'entity' => $entity));
+      'entity' => $entity,
+    ));
     $all_day2 = theme('date_all_day', array(
       'field' => $field,
       'instance' => $instance,
@@ -99,7 +100,8 @@ function hook_date_formatter_dates_alter(&$dates, $context) {
       'date2' => $date2,
       'format' => $format,
       'entity_type' => $entity_type,
-      'entity' => $entity));
+      'entity' => $entity,
+    ));
     $dates['value']['formatted_time'] = theme('date_all_day_label');
     $dates['value2']['formatted_time'] = theme('date_all_day_label');
     $dates['value']['formatted'] = $all_day1;
@@ -117,7 +119,7 @@ function hook_date_formatter_dates_alter(&$dates, $context) {
  * @param array $input
  *   The array of input values to be validated.
  */
-function hook_date_text_pre_validate_alter(&$element, &$form_state, &$input) {
+function hook_date_text_pre_validate_alter(array &$element, array &$form_state, array &$input) {
   // Let Date module massage the format for all day values so they will pass
   // validation. The All day flag, if used, actually exists on the parent
   // element.
@@ -134,7 +136,7 @@ function hook_date_text_pre_validate_alter(&$element, &$form_state, &$input) {
  * @param array $input
  *   The array of input values to be validated.
  */
-function hook_date_select_pre_validate_alter(&$element, &$form_state, &$input) {
+function hook_date_select_pre_validate_alter(array &$element, array &$form_state, array &$input) {
   // Let Date module massage the format for all day values so they will pass
   // validation. The All day flag, if used, actually exists on the parent
   // element.
@@ -151,7 +153,7 @@ function hook_date_select_pre_validate_alter(&$element, &$form_state, &$input) {
  * @param array $input
  *   The array of input values to be validated.
  */
-function hook_date_popup_pre_validate_alter(&$element, &$form_state, &$input) {
+function hook_date_popup_pre_validate_alter(array &$element, array &$form_state, array &$input) {
   // Let Date module massage the format for all day values so they will pass
   // validation. The All day flag, if used, actually exists on the parent
   // element.
@@ -173,9 +175,8 @@ function hook_date_popup_pre_validate_alter(&$element, &$form_state, &$input) {
  *
  * @see date_combo_element_process()
  */
-function hook_date_combo_pre_validate_alter(&$element, &$form_state, $context) {
+function hook_date_combo_pre_validate_alter(array &$element, array &$form_state, array $context) {
   if (!empty($context['item']['all_day'])) {
-
     $field = $context['field'];
 
     // If we have an all day flag on this date and the time is empty, change the
@@ -200,12 +201,12 @@ function hook_date_combo_pre_validate_alter(&$element, &$form_state, $context) {
  *   A keyed array containing the current state of the form.
  * @param array $context
  *   An associative array containing the following keys:
- *  - field: The $field array.
- *  - instance: The $instance array.
- *  - item: The $item array.
- *  - element: The $element array.
+ *   - field: The $field array.
+ *   - instance: The $instance array.
+ *   - item: The $item array.
+ *   - element: The $element array.
  */
-function hook_date_combo_validate_date_start_alter(&$date, &$form_state, $context) {
+function hook_date_combo_validate_date_start_alter(object &$date, array &$form_state, array $context) {
   // If this is an 'All day' value, set the time to midnight.
   if (!empty($context['element']['#date_is_all_day'])) {
     $date->setTime(0, 0, 0);
@@ -224,12 +225,12 @@ function hook_date_combo_validate_date_start_alter(&$date, &$form_state, $contex
  *   A keyed array containing the current state of the form.
  * @param array $context
  *   An associative array containing the following keys:
- *  - field: The $field array.
- *  - instance: The $instance array.
- *  - item: The $item array.
- *  - element: The $element array.
+ *   - field: The $field array.
+ *   - instance: The $instance array.
+ *   - item: The $item array.
+ *   - element: The $element array.
  */
-function hook_date_combo_validate_date_end_alter(&$date, &$form_state, $context) {
+function hook_date_combo_validate_date_end_alter(object &$date, array &$form_state, array $context) {
   // If this is an 'All day' value, set the time to midnight.
   if (!empty($context['element']['#date_is_all_day'])) {
     $date->setTime(0, 0, 0);
@@ -249,7 +250,7 @@ function hook_date_combo_validate_date_end_alter(&$date, &$form_state, $context)
  *
  * @see date_text_element_process()
  */
-function hook_date_text_process_alter(&$element, &$form_state, $context) {
+function hook_date_text_process_alter(array &$element, array &$form_state, array $context) {
   $all_day_id = !empty($element['#date_all_day_id']) ? $element['#date_all_day_id'] : '';
   if ($all_day_id != '') {
     // All Day handling on text dates works only if the user leaves the time out
@@ -270,7 +271,7 @@ function hook_date_text_process_alter(&$element, &$form_state, $context) {
  *
  * @see date_select_element_process()
  */
-function hook_date_select_process_alter(&$element, &$form_state, $context) {
+function hook_date_select_process_alter(array &$element, array &$form_state, array $context) {
   // Hide or show the element in reaction to the all_day status for the element.
   $all_day_id = !empty($element['#date_all_day_id']) ? $element['#date_all_day_id'] : '';
   if ($all_day_id != '') {
@@ -299,7 +300,7 @@ function hook_date_select_process_alter(&$element, &$form_state, $context) {
  *
  * @see date_popup_element_process()
  */
-function hook_date_popup_process_alter(&$element, &$form_state, $context) {
+function hook_date_popup_process_alter(array &$element, array &$form_state, array $context) {
   // Hide or show the element in reaction to the all_day status for the element.
   $all_day_id = !empty($element['#date_all_day_id']) ? $element['#date_all_day_id'] : '';
   if ($all_day_id != '' && array_key_exists('time', $element)) {
@@ -324,7 +325,7 @@ function hook_date_popup_process_alter(&$element, &$form_state, $context) {
  *   - instance: The $instance array.
  *   - form: Nested array of form elements that comprise the form.
  */
-function hook_date_combo_process_alter(&$element, &$form_state, $context) {
+function hook_date_combo_process_alter(array &$element, array &$form_state, array $context) {
   $field = $context['field'];
   $instance = $context['instance'];
   $field_name = $element['#field_name'];
@@ -365,7 +366,7 @@ function hook_date_combo_process_alter(&$element, &$form_state, $context) {
  *
  * @see date_timezone_element_process()
  */
-function hook_date_timezone_process_alter(&$element, &$form_state, $context) {
+function hook_date_timezone_process_alter(array &$element, array &$form_state, array $context) {
   // @todo.
 }
 
@@ -382,7 +383,7 @@ function hook_date_timezone_process_alter(&$element, &$form_state, $context) {
  *
  * @see date_year_range_element_process()
  */
-function hook_date_year_range_process_alter(&$element, &$form_state, $context) {
+function hook_date_year_range_process_alter(array &$element, array &$form_state, array $context) {
   // @todo.
 }
 
@@ -399,7 +400,7 @@ function hook_date_year_range_process_alter(&$element, &$form_state, $context) {
  *
  * @see hook_field_settings_form()
  */
-function hook_date_field_settings_form_alter(&$form, $context) {
+function hook_date_field_settings_form_alter(array &$form, array $context) {
   $field = $context['field'];
   $instance = $context['instance'];
   $has_data = $context['has_data'];
@@ -427,7 +428,7 @@ function hook_date_field_settings_form_alter(&$form, $context) {
  *
  * @see hook_field_instance_settings_form()
  */
-function hook_date_field_instance_settings_form_alter(&$form, $context) {
+function hook_date_field_instance_settings_form_alter(array &$form, array $context) {
   $field = $context['field'];
   $instance = $context['instance'];
   $form['new_setting'] = array(
@@ -449,7 +450,7 @@ function hook_date_field_instance_settings_form_alter(&$form, $context) {
  *
  * @see hook_field_widget_settings_form()
  */
-function hook_date_field_widget_settings_form_alter(&$form, $context) {
+function hook_date_field_widget_settings_form_alter(array &$form, array $context) {
   $field = $context['field'];
   $instance = $context['instance'];
   $form['new_setting'] = array(
@@ -474,7 +475,7 @@ function hook_date_field_widget_settings_form_alter(&$form, $context) {
  *
  * @see hook_field_formatter_settings_form()
  */
-function hook_date_field_formatter_settings_form_alter(&$form, &$form_state, $context) {
+function hook_date_field_formatter_settings_form_alter(array &$form, array &$form_state, array $context) {
   $field = $context['field'];
   $instance = $context['instance'];
   $view_mode = $context['view_mode'];
@@ -486,7 +487,8 @@ function hook_date_field_formatter_settings_form_alter(&$form, &$form_state, $co
       '#type' => 'select',
       '#options' => array(
         'show' => t('Show repeat rule'),
-        'hide' => t('Hide repeat rule')),
+        'hide' => t('Hide repeat rule'),
+      ),
       '#default_value' => $settings['show_repeat_rule'],
       '#access' => $field['settings']['repeat'],
       '#weight' => 5,
@@ -508,7 +510,7 @@ function hook_date_field_formatter_settings_form_alter(&$form, &$form_state, $co
  *
  * @see hook_field_formatter_settings_summary()
  */
-function hook_date_field_formatter_settings_summary_alter(&$summary, $context) {
+function hook_date_field_formatter_settings_summary_alter(array &$summary, array $context) {
   $field = $context['field'];
   $instance = $context['instance'];
   $view_mode = $context['view_mode'];
diff --git a/drupal7/sites/all/modules/date/date.devel_generate.inc b/drupal7/sites/all/modules/date/date.devel_generate.inc
index 6c61e23c..d6e2433c 100644
--- a/drupal7/sites/all/modules/date/date.devel_generate.inc
+++ b/drupal7/sites/all/modules/date/date.devel_generate.inc
@@ -7,22 +7,15 @@
 
 /**
  * Implements hook_devel_generate().
- *
- * Included only when needed.
  */
 function date_devel_generate($entity, $field, $instance, $bundle) {
-
   $entity_field = array();
   if (isset($instance['widget']['settings']['year_range'])) {
     $split = explode(':', $instance['widget']['settings']['year_range']);
     // Determine how much to go back and forward depending on whether a relative
     // number of years (with - or + sign) or an absolute year is given.
-    $back = strpos($split[0], '-') === 0
-      ? str_replace('-', '', $split[0])
-      : date_format(date_now(), 'Y') - $split[0];
-    $forward = strpos($split[1], '+') === 0
-      ? str_replace('+', '', $split[1])
-      : $split[1] - date_format(date_now(), 'Y');
+    $back = $split[0];
+    $forward = $split[1];
   }
   else {
     $back = 2;
@@ -30,7 +23,8 @@ function date_devel_generate($entity, $field, $instance, $bundle) {
   }
   // Pick a random year within the time range,
   // and a random second within that year.
-  $year = date_format(date_now(), 'Y') - $back + mt_rand(0, ($forward + $back));
+  $this_year = date_format(date_now(), 'Y');
+  $year = mt_rand($this_year + $back, $this_year + $forward);
   $start = new DateObject($year . '-01-01 00:00:00', date_get_timezone_db($field['settings']['tz_handling']));
   $leap = date_format($start, 'L');
   $max_days = $leap ? 366 : 365;
@@ -39,17 +33,16 @@ function date_devel_generate($entity, $field, $instance, $bundle) {
   $increment = $instance['widget']['settings']['increment'];
   date_increment_round($start, $increment);
 
-  // Modify End date by 1 hour to 3 days, shorter for repeating dates
-  // longer for others.
-  $start2 = clone($start);
+  // Modify End date by 1 hour to 3 days, shorter for repeating dates longer
+  // for others.
+  $start2 = clone $start;
   $max = !empty($field['settings']['repeat']) ? 720 : 4320;
   $max = 240;
   date_modify($start2, '+' . mt_rand(60, $max) . ' minutes');
   date_increment_round($start2, $increment);
 
   if ($field['settings']['tz_handling'] == 'date') {
-    // Choose a random timezone.
-    // Not all keys exist, so we have to check.
+    // Choose a random timezone. Not all keys exist, so we have to check.
     $timezones = array_keys(date_timezone_names(TRUE));
     $key = mt_rand(0, count($timezones) - 1);
     if (!array_key_exists($key, $timezones)) {
@@ -86,5 +79,4 @@ function date_devel_generate($entity, $field, $instance, $bundle) {
   date_timezone_set($start2, timezone_open($timezone));
   $entity_field['offset2'] = date_offset_get($start2);
   return $entity_field;
-
 }
diff --git a/drupal7/sites/all/modules/date/date.field.inc b/drupal7/sites/all/modules/date/date.field.inc
index 7aef97be..275caf8c 100644
--- a/drupal7/sites/all/modules/date/date.field.inc
+++ b/drupal7/sites/all/modules/date/date.field.inc
@@ -15,10 +15,11 @@ function date_field_formatter_info() {
       'field types' => array('date', 'datestamp', 'datetime'),
       'settings' => array(
         'format_type' => 'long',
+        'custom_date_format' => '',
+        'fromto' => 'both',
         'multiple_number' => '',
         'multiple_from' => '',
         'multiple_to' => '',
-        'fromto' => 'both',
         'show_remaining_days' => FALSE,
       ),
     ),
@@ -28,7 +29,7 @@ function date_field_formatter_info() {
       'settings' => array(
         'interval' => 2,
         'interval_display' => 'time ago',
-        'use_end_date' => false,
+        'use_end_date' => FALSE,
       ),
     ),
     'date_plain' => array(
@@ -53,7 +54,6 @@ function date_field_formatter_settings_form($field, $instance, $view_mode, $form
 
     default:
       $form = date_default_formatter_settings_form($field, $instance, $view_mode, $form, $form_state);
-      break;
   }
   $context = array(
     'field' => $field,
@@ -78,7 +78,6 @@ function date_field_formatter_settings_summary($field, $instance, $view_mode) {
 
     default:
       $summary = date_default_formatter_settings_summary($field, $instance, $view_mode);
-      break;
   }
   $context = array(
     'field' => $field,
@@ -92,28 +91,24 @@ function date_field_formatter_settings_summary($field, $instance, $view_mode) {
 
 /**
  * Implements hook_field_formatter_view().
- *
- * Useful values:
- *
- *   $entity->date_id
- *     If set, this will show only an individual date on a field with
- *     multiple dates. The value should be a string that contains
- *     the following values, separated with periods:
- *     - module name of the module adding the item
- *     - node nid
- *     - field name
- *     - delta value of the field to be displayed
- *     - other information the module's custom theme might need
- *
- *     Used by the calendar module and available for other uses.
- *     example: 'date:217:field_date:3:test'
- *
- *   $entity->date_repeat_show
- *     If true, tells the theme to show all the computed values
- *     of a repeating date. If not true or not set, only the
- *     start date and the repeat rule will be displayed.
  */
 function date_field_formatter_view($entity_type, $entity, $field, $instance, $langcode, $items, $display) {
+  // Useful values:
+  // - $entity->date_id
+  //   If set, this will show only an individual date on a field with
+  //   multiple dates. The value should be a string that contains
+  //   the following values, separated with periods:
+  //   - module name of the module adding the item
+  //   - node nid
+  //   - field name
+  //   - delta value of the field to be displayed
+  //   - other information the module's custom theme might need
+  //   Used by the calendar module and available for other uses.
+  //   example: 'date:217:field_date:3:test'
+  // - $entity->date_repeat_show
+  //   If TRUE, tells the theme to show all the computed values
+  //   of a repeating date. If not TRUE or not set, only the
+  //   start date and the repeat rule will be displayed.
   $element = array();
   $settings = $display['settings'];
   $formatter = $display['type'];
@@ -176,8 +171,9 @@ function date_field_formatter_view($entity_type, $entity, $field, $instance, $la
             $element[$delta] = array(
               '#markup' => t('!start-date to !end-date', array(
                 '!start-date' => $item['value'],
-                '!end-date' => $item['value2']
-              )));
+                '!end-date' => $item['value2'],
+              )),
+            );
           }
         }
       }
@@ -215,8 +211,13 @@ function date_field_formatter_view($entity_type, $entity, $field, $instance, $la
           }
         }
       }
-      break;
   }
+
+  // Add the CSS stylesheet only if we have something to display.
+  if (!empty($element)) {
+    $element['#attached']['css'][] = drupal_get_path('module', 'date_api') . '/date.css';
+  }
+
   return $element;
 }
 
@@ -224,8 +225,7 @@ function date_field_formatter_view($entity_type, $entity, $field, $instance, $la
  * Implements hook_field_is_empty().
  */
 function date_field_is_empty($item, $field) {
-  // Sometimes a $item is a date object.
-  // Coming from repeating dates. Why??
+  // Sometimes a $item is a date object. Coming from repeating dates. Why??
   if (!is_array($item)) {
     return FALSE;
   }
@@ -373,12 +373,13 @@ function date_field_validate($entity_type, $entity, $field, $instance, $langcode
     foreach ($items as $delta => $item) {
       if (is_array($item) && isset($item['value'])) {
         $process = date_process_values($field, $instance);
-        $date1 = new DateObject($item['value'], $item['timezone'], date_type_format($field['type']));
-        if (count($process) == 1 || (empty($item['value2']) && $item['value2'] !== 0)) {
-          $date2 = clone($date1);
+        $timezone = date_get_timezone($field['settings']['tz_handling'], isset($item['timezone']) ? $item['timezone'] : '');
+        $date1 = new DateObject($item['value'], $timezone, date_type_format($field['type']));
+        if (count($process) === 1 || (empty($item['value2']) && $item['value2'] !== 0)) {
+          $date2 = clone $date1;
         }
         else {
-          $date2 = new DateObject($item['value2'], $item['timezone'], date_type_format($field['type']));
+          $date2 = new DateObject($item['value2'], $timezone, date_type_format($field['type']));
         }
         $valid1 = $date1->validGranularity($field['settings']['granularity'], $flexible);
         $valid2 = $date2->validGranularity($field['settings']['granularity'], $flexible);
@@ -411,6 +412,7 @@ function date_field_presave($entity_type, $entity, $field, $instance, $langcode,
   if (empty($items)) {
     return;
   }
+
   // Add some information needed to interpret token values.
   $values = $items;
   foreach ($values as $delta => $item) {
@@ -454,11 +456,10 @@ function date_field_update($entity_type, $entity, $field, $instance, $langcode,
 
 /**
  * Implements hook_field_instance_settings_form().
- *
- * Wrapper functions for date administration, included only when processing
- * field settings.
  */
 function date_field_instance_settings_form($field, $instance) {
+  // Wrapper functions for date administration, included only when processing
+  // field settings.
   module_load_include('inc', 'date', 'date_admin');
   return _date_field_instance_settings_form($field, $instance);
 }
@@ -505,15 +506,14 @@ function date_field_settings_validate(&$form, &$form_state) {
 
 /**
  * Implements hook_content_migrate_field_alter().
- *
- * Use this to tweak the conversion of field settings from the D6 style to the
- * D7 style for specific situations not handled by basic conversion, as when
- * field types or settings are changed.
- *
- * $field_value['widget_type'] is available to see what widget type was
- * originally used.
  */
 function date_content_migrate_field_alter(&$field_value, $instance_value) {
+  // Use this to tweak the conversion of field settings from the D6 style to the
+  // D7 style for specific situations not handled by basic conversion, as when
+  // field types or settings are changed.
+  //
+  // $field_value['widget_type'] is available to see what widget type was
+  // originally used.
   switch ($field_value['module']) {
     case 'date':
       // Those settings do not exist anymore, or have been moved to the instance
@@ -526,15 +526,13 @@ function date_content_migrate_field_alter(&$field_value, $instance_value) {
 
 /**
  * Implements hook_content_migrate_instance_alter().
- *
- * Use this to tweak the conversion of instance or widget settings from the D6
- * style to the D7 style for specific situations not handled by basic
- * conversion, as when formatter or widget names or settings are changed.
  */
 function date_content_migrate_instance_alter(&$instance_value, $field_value) {
+  // Use this to tweak the conversion of instance or widget settings from the D6
+  // style to the D7 style for specific situations not handled by basic
+  // conversion, as when formatter or widget names or settings are changed.
   switch ($instance_value['widget']['module']) {
     case 'date':
-
       // Some settings have been moved from field to instance.
       $instance_value['widget']['settings']['repeat_collapsed'] = $field_value['settings']['repeat_collapsed'];
 
diff --git a/drupal7/sites/all/modules/date/date.info b/drupal7/sites/all/modules/date/date.info
index 28263b42..7b913f22 100644
--- a/drupal7/sites/all/modules/date/date.info
+++ b/drupal7/sites/all/modules/date/date.info
@@ -1,23 +1,33 @@
 name = Date
 description = Makes date/time fields available.
-dependencies[] = date_api
+dependencies[] = date:date_api
 package = Date/Time
 core = 7.x
-php = 5.2
+
+; Integration with the migrate module.
 files[] = date.migrate.inc
-files[] = tests/date_api.test
-files[] = tests/date.test
-files[] = tests/date_field.test
-files[] = tests/date_migrate.test
-files[] = tests/date_validation.test
-files[] = tests/date_timezone.test
-files[] = tests/date_views_pager.test
-files[] = tests/date_views_popup.test
-files[] = tests/date_form.test
 
-; Information added by Drupal.org packaging script on 2017-04-07
-version = "7.x-2.10"
+; Dependencies for test coverage.
+test_dependencies[] = entity:entity
+test_dependencies[] = features:features (2.x)
+test_dependencies[] = migrate:migrate
+test_dependencies[] = views:views
+
+; Test coverage: standalone tests.
+files[] = tests/DateEmwTestCase.test
+files[] = tests/DateFormTestCase.test
+files[] = tests/DateMigrateTestCase.test
+files[] = tests/DateNowUnitTestCase.test
+
+; The remaining tests depend upon this one.
+files[] = tests/DateFieldTestBase.test
+files[] = tests/DateFieldTestCase.test
+files[] = tests/DateTimezoneTestCase.test
+files[] = tests/DateUiTestCase.test
+files[] = tests/DateValidationTestCase.test
+
+; Information added by Drupal.org packaging script on 2021-03-05
+version = "7.x-2.11"
 core = "7.x"
 project = "date"
-datestamp = "1491562090"
-
+datestamp = "1614952728"
diff --git a/drupal7/sites/all/modules/date/date.install b/drupal7/sites/all/modules/date/date.install
index 765b90cf..a75b1ca3 100644
--- a/drupal7/sites/all/modules/date/date.install
+++ b/drupal7/sites/all/modules/date/date.install
@@ -14,6 +14,7 @@ function date_field_schema($field) {
     case 'datestamp':
       $db_columns['value'] = array(
         'type' => 'int',
+        'size' => 'big',
         'not null' => FALSE,
         'sortable' => TRUE,
         'views' => TRUE,
@@ -41,7 +42,6 @@ function date_field_schema($field) {
         'sortable' => TRUE,
         'views' => TRUE,
       );
-      break;
   }
 
   // If a second date is needed for 'End date', make a copy of the first one.
@@ -51,6 +51,16 @@ function date_field_schema($field) {
     // We don't want Field API to create additional columns, just the first.
     // We modify them our own way in views data.
     $db_columns['value2']['views'] = FALSE;
+
+    // Create a compound index on value and value2 and an index on value2.
+    $indexes = array(
+      'value' => array('value', 'value2'),
+      'value2' => array('value2'),
+    );
+  }
+  else {
+    // Otherwise just an index on value.
+    $indexes = array('value' => array('value'));
   }
   // Timezone and offset columns are used only if date-specific dates are used.
   if (isset($field['settings']['tz_handling']) && $field['settings']['tz_handling'] == 'date') {
@@ -72,7 +82,7 @@ function date_field_schema($field) {
         'type' => 'int',
         'not null' => FALSE,
         'sortable' => TRUE,
-        'views' => FALSE
+        'views' => FALSE,
       );
     }
   }
@@ -84,7 +94,7 @@ function date_field_schema($field) {
       'views' => FALSE,
     );
   }
-  return array('columns' => $db_columns);
+  return array('columns' => $db_columns, 'indexes' => $indexes);
 }
 
 /**
@@ -134,13 +144,14 @@ function date_update_7001() {
   $query->condition(db_or()->condition('fc.type', 'date')->condition('fc.type', 'datestamp')->condition('fc.type', 'datetime'));
   $results = $query->execute();
 
+  $allowed_types = array(
+    'date_popup_repeat',
+    'date_text_repeat',
+    'date_select_repeat',
+  );
   foreach ($results as $record) {
     $instance = unserialize($record['data']);
-    if (in_array($instance['widget']['type'], array(
-        'date_popup_repeat',
-        'date_text_repeat',
-        'date_select_repeat'
-      ))) {
+    if (in_array($instance['widget']['type'], $allowed_types)) {
       $instance['widget']['type'] = str_replace('_repeat', '', $instance['widget']['type']);
       db_update('field_config_instance')
         ->fields(array(
@@ -212,3 +223,93 @@ function date_update_7005() {
   // @see https://www.drupal.org/node/1355256
   date_update_7004();
 }
+
+/**
+ * Add date value indexes to existed field tables.
+ */
+function date_update_7006() {
+  // Get all fields provided by the Data module.
+  $query = db_select('field_config', 'f')
+    ->fields('f', array('id', 'field_name', 'data'))
+    ->condition('f.type', array('datetime', 'date', 'datestamp'));
+
+  // Special handling for the Encrypt module.
+  if (module_exists('field_encrypt')) {
+    $query->condition('f.data', '%' . db_like(' field_encrypt";a:1:{s:7:"encrypt";i:0 ') . '%', 'LIKE');
+  }
+
+  // Complete the query.
+  $fields = $query->execute()->fetchAllAssoc('id');
+
+  foreach ($fields as $id => $info) {
+    $field_info = field_info_field($info->field_name);
+
+    // Add indexes only for SQL storage fields.
+    if ($field_info['storage']['type'] != 'field_sql_storage') {
+      continue;
+    }
+
+    $tables = array(
+      key($field_info['storage']['details']['sql']['FIELD_LOAD_CURRENT']),
+      key($field_info['storage']['details']['sql']['FIELD_LOAD_REVISION']),
+    );
+
+    $data = unserialize($info->data);
+    $field_name = $info->field_name . '_value';
+    $field_name2 = $info->field_name . '_value2';
+
+    // Build indexes.
+    $indexes = $data['indexes'] = array();
+    if (!empty($data['settings']['todate'])) {
+      $indexes[$field_name] = array($field_name, $field_name2);
+      $indexes[$field_name2] = array($field_name2);
+      $data['indexes']['value'] = array('value', 'value2');
+      $data['indexes']['value2'] = array('value2');
+    }
+    else {
+      $indexes[$field_name] = array($field_name);
+      $data['indexes']['value'] = array('value');
+    }
+
+    // Add missed indexes to tables.
+    foreach ($indexes as $name => $index) {
+      foreach ($tables as $table) {
+        if (!db_index_exists($table, $name)) {
+          db_add_index($table, $name, $index);
+        }
+      }
+    }
+
+    // Fix date fields storage 'field_config' indexes.
+    db_update('field_config')
+      ->fields(array('data' => serialize($data)))
+      ->condition('id', $id)
+      ->execute();
+  }
+}
+
+/**
+ * Update datestamp field schema to use 'big' integers.
+ */
+function date_update_7007() {
+  $fields = field_read_fields(array('type' => 'datestamp'));
+  foreach ($fields as $field_name => $field) {
+    foreach (array_intersect_key($field['columns'], drupal_map_assoc(array('value', 'value2'))) as $column_name => $schema) {
+      $schema['size'] = 'big';
+      $column = $field_name . '_' . $column_name;
+      if (db_table_exists('field_data_' . $field_name)) {
+        db_change_field('field_data_' . $field_name, $column, $column, $schema);
+      }
+      if (db_table_exists('field_revision_' . $field_name)) {
+        db_change_field('field_revision_' . $field_name, $column, $column, $schema);
+      }
+    }
+  }
+}
+
+/**
+ * The date_migrate_example module was renamed.
+ */
+function date_update_7200() {
+  db_delete('system')->condition('name', 'date_migrate_example')->execute();
+}
